package aoc3.client;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.Properties;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 02.jul.2007
 * Time: 13:25:14
 * To change this template use File | Settings | File Templates.
 */
final class DebugConsole extends JFrame implements ActionListener
{
  private final JButton bclearconsole = new JButton("Slett");
  private final JButton bsaveconsole = new JButton("Lagre...");

  DebugConsole()
  {
    super("AoC: Konsoll");

    bclearconsole.setMnemonic('c');
    bclearconsole.addActionListener(this);
    bsaveconsole.setMnemonic('s');
    bsaveconsole.addActionListener(this);

    JTextArea taconsole = Client.getConsoleText();
    taconsole.setEditable(false);

    JPanel lowerpanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
    lowerpanel.add(bclearconsole);
    lowerpanel.add(bsaveconsole);

    JPanel pane = (JPanel)getContentPane();
    pane.setLayout(new BorderLayout());
    pane.add(new JScrollPane(taconsole), BorderLayout.CENTER);
    pane.add(lowerpanel, BorderLayout.SOUTH);

    setSize(600, 450);
    Dimension screen = getToolkit().getScreenSize();
    int x = (screen.width - getSize().width) / 2;
    int y = (screen.height - getSize().height) / 2;
    setLocation(Math.max(0, x), Math.max(0, y));
  }

// --------------------- Begin Interface ActionListener ---------------------

  public void actionPerformed(ActionEvent event)
  {
    if (event.getSource() == bclearconsole)
      Client.getConsoleText().setText("");
    else if (event.getSource() == bsaveconsole) {
      JFileChooser chooser = new JFileChooser(".");
      chooser.setDialogTitle("Lagre konsoll");
      chooser.setSelectedFile(new File("aocdebuglog.txt"));
      if (chooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
        File output = chooser.getSelectedFile();
        if (output.exists()) {
          String options[] = {"Overskriv", "Avbryt"};
          if (JOptionPane.showOptionDialog(this, output + " finnes, overskriv?", "Lagre konsoll", JOptionPane.YES_NO_OPTION,
                                           JOptionPane.WARNING_MESSAGE, null, options, options[0]) == 1)
            return;
        }
        try {
          PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(output)));
          pw.println("Age of Computers - konsoll");
          pw.println(Client.getConsoleText().getText());
          pw.println();
          Properties props = System.getProperties();
          for (Object key : props.keySet())
            pw.println(key + "=" + props.get(key));
          pw.close();
          JOptionPane.showMessageDialog(this, "Konsollen lagret til " + output, "Lagring ferdig",
                                        JOptionPane.INFORMATION_MESSAGE);
        } catch (IOException e) {
          JOptionPane.showMessageDialog(this, "Feil under lagring av " + output, "Feil",
                                        JOptionPane.ERROR_MESSAGE);
          e.printStackTrace();
        }
      }
    }
  }

// --------------------- End Interface ActionListener ---------------------


}
