package aoc3.client;

import aoc3.db.Text;
import aoc3.event.HTMLEventListener;
import aoc3.net.ClientToServer;

import javax.swing.*;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 12.apr.2005
 * Time: 18:56:43
 * To change this template use File | Settings | File Templates.
 */
final class HtmlPanel extends JPanel implements HTMLEventListener
{
  private final JButton bBack = new JButton("Tilbake til brett");
  private final JEditorPane epHTML = new JEditorPane();
  private final JLabel idLabel = new JLabel();

  HtmlPanel(Client main, ClientToServer connection)
  {
    super(new BorderLayout());
    epHTML.setEditable(false);
    epHTML.setContentType("text/html");
    bBack.addActionListener(main);
    bBack.setActionCommand(Client.ACTION_BACK);

    JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
    panel.add(bBack);
    panel.add(idLabel);

    JScrollPane scrollHTML = new JScrollPane(epHTML);
    scrollHTML.setPreferredSize(new Dimension(500, 400));
    add(scrollHTML, BorderLayout.CENTER);
    add(panel, BorderLayout.SOUTH);
    connection.addHTMLListener(this);
  }

// --------------------- Begin Interface HTMLEventListener ---------------------

  public void textReceived(Text text)
  {
    if (text == null) {
      epHTML.setText("<html><h1>Fant ikke teksten</h1></html>");
      epHTML.setCaretPosition(0);
      idLabel.setText("");
    }
    else {
      epHTML.setText(ImageURLParser.parseHTML("<h1>" + text.getName() + "</h1>" + text.getText()));
      epHTML.setCaretPosition(0);
      idLabel.setText("Ark nr " + text.getId());
    }
  }

// --------------------- End Interface HTMLEventListener ---------------------
}

