package aoc3.client;

import javax.swing.text.*;
import javax.swing.text.html.*;
import java.io.IOException;
import java.io.StringReader;
import java.util.Enumeration;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 15.apr.2005
 * Time: 12:53:50
 * To change this template use File | Settings | File Templates.
 */
public final class ImageURLParser
{
  private static final String HEADER = "<html><head>\n" +
                                       " <style type=\"text/css\"> div.p { margin-top: 7pt;}</style>\n" +
                                       " <style type=\"text/css\"><!--\n" +
                                       " td div.comp { margin-top: -0.6ex; margin-bottom: -1ex;}\n" +
                                       " td div.comb { margin-top: -0.6ex; margin-bottom: -.6ex;}\n" +
                                       " td div.hrcomp { line-height: 0.9; margin-top: -0.8ex; margin-bottom: -1ex;}\n" +
                                       " td div.norm {line-height:normal;}\n" +
                                       " span.roman {font-family: serif; font-style: normal; font-weight: normal;}\n" +
                                       " span.overacc2 {position: relative;  left: .8em; top: -1.2ex;}\n" +
                                       " span.overacc1 {position: relative;  left: .6em; top: -1.2ex;} --></style></head>";
  private static final String FOOTER = "\n</html>";
  private static final String IMAGEROOT = "/data/";

  public static String parseHTML(String html)
  {
    ParserGetter kit = new ParserGetter();
    html = HEADER + html + FOOTER;
    HTMLEditorKit.Parser parser = kit.getParser();
    StringReader sr = new StringReader(html);
    StringBuilder result = new StringBuilder();
    HTMLEditorKit.ParserCallback callback = new ImageURLFixer(result);
    try {
      parser.parse(sr, callback, false);
      return result.toString();
    } catch (IOException e) {
      e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      return html;
    }
  }

// -------------------------- INNER CLASSES --------------------------

  private static final class ImageURLFixer extends HTMLEditorKit.ParserCallback
  {
    private final StringBuilder result;

    private ImageURLFixer(StringBuilder result)
    {
      this.result = result;
    }

    public void handleText(char[] data, int pos)
    {
      if (data.length != 1 || data[0] != '>') {    // BugFix for simpleTags som tth ender med />
        String temp = String.valueOf(data);
        temp = temp.replaceAll("<", "&lt;");      // BugFix: mindre enn tegn vises ikke
        result.append(temp);
      }
    }

    public void handleComment(char[] data, int pos)
    {
      result.append("<!-- ").append(data).append(" -->");
    }

    public void handleStartTag(HTML.Tag t, MutableAttributeSet a, int pos)
    {
      result.append('<').append(t);
      Enumeration e = a.getAttributeNames();
      while (e.hasMoreElements()) {
        Object name = e.nextElement();
        Object value = a.getAttribute(name);
        if (t == HTML.Tag.IMG && name == HTML.Attribute.SRC)
          value = "http://" + Client.getServer() + IMAGEROOT + value.toString();
        result.append(' ').append(name).append("=\"").append(value).append('\"');
      }
      result.append('>');
    }

    public void handleEndTag(HTML.Tag t, int pos)
    {
      result.append("</").append(t).append('>');
    }

    public void handleSimpleTag(HTML.Tag t, MutableAttributeSet a, int pos)
    {
      result.append('<').append(t);
      Enumeration e = a.getAttributeNames();
      while (e.hasMoreElements()) {
        Object name = e.nextElement();
        Object value = a.getAttribute(name);
        if (t == HTML.Tag.IMG && name == HTML.Attribute.SRC)
          value = "http://" + Client.getServer() + IMAGEROOT + value.toString();
        result.append(' ').append(name).append("=\"").append(value).append('\"');
      }
      result.append('>');
    }
  }

  private static final class ParserGetter extends HTMLEditorKit
  {
    public HTMLEditorKit.Parser getParser()
    {
      return super.getParser();
    }
  }
}

