package aoc3.client;

import aoc3.db.LevelItem;
import aoc3.icons.Icons;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 24.apr.2005
 * Time: 15:09:21
 * To change this template use File | Settings | File Templates.
 */
final class StaticAnimation
{
  private static final int MILLIS_PER_FRAME = 75;
  private static long time;
  private final Image image;
  private final Rectangle frameSize;
  private final int numFramesX;
  private final int numFramesY;

  static void setCurrenTimeMillis(long time)
  {
    StaticAnimation.time = time;
  }

  StaticAnimation(int animNr)
  {
    image = Icons.getAnimation(animNr).getImage();
    frameSize = Icons.getFrameSize(animNr);
    numFramesX = Math.max(1, image.getWidth(null) / frameSize.width);
    numFramesY = Math.max(1, image.getHeight(null) / frameSize.height);
  }

  void draw(Graphics2D g2d, LevelItem item)
  {
    int posX = item.getPosx();
    int posY = item.getPosy();

    // Modulate frame to sprite anim.
    Long tempLong = time / MILLIS_PER_FRAME;
    Long tempX = tempLong % numFramesX;
    Long tempY = (tempLong / numFramesX) % numFramesY;
    int frameNumX = tempX.intValue();
    int frameNumY = tempY.intValue();

    // Then copy that sprite to viewable pane.
    g2d.drawImage(image,
                  posX,
                  posY,
                  posX + frameSize.width,
                  posY + frameSize.height,
                  frameNumX * frameSize.width,
                  frameNumY * frameSize.height,
                  (frameNumX + 1) * frameSize.width,
                  (frameNumY + 1) * frameSize.height,
                  null);
  }
}

