package aoc3.client.question;

import aoc3.db.*;
import aoc3.net.ClientToServer;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 19.jul.2005
 * Time: 17:25:06
 * To change this template use File | Settings | File Templates.
 */
public final class InputPanel extends AbstractQuestionPanel
{
  private JTextField tfAnswer;

  public InputPanel(ClientToServer connection, InputQuestion question, QuestionCategory questionCategory)
  {
    super(connection, question, questionCategory, question.getText());
  }

// --------------------- Begin Interface ActionListener ---------------------

  public void actionPerformed(ActionEvent event)
  {
    if (readOnly)
      return;
    if (event.getSource() == bAnswer || event.getSource() == tfAnswer) {
      bAnswer.setEnabled(false);
      tfAnswer.setEnabled(false);
      connection.submitStaticAnswer(question.getId(), tfAnswer.getText());
    }
  }

// --------------------- End Interface ActionListener ---------------------

  void initAnswerComponents(Question question, GridBagLayout gbl, GridBagConstraints gbc)
  {
    tfAnswer = new JTextField(10);
    tfAnswer.addActionListener(this);
    tfAnswer.setMinimumSize(new Dimension(100, bAnswer.getMinimumSize().height));
    tfAnswer.setPreferredSize(tfAnswer.getMinimumSize());

    JLabel label = new JLabel(" Svar:");
    gbc.gridwidth = 1;
    gbc.weightx = 0.0;
    gbc.weighty = 0.0;
    gbl.setConstraints(label, gbc);
    add(label);
    gbl.setConstraints(tfAnswer, gbc);
    add(tfAnswer);
  }

  void initReadOnlyComponents(Question question, GridBagLayout gbl, GridBagConstraints gbc)
  {
  }
}

