package aoc3.client.question;

import aoc3.db.*;
import aoc3.net.ClientToServer;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 19.jul.2005
 * Time: 17:24:13
 * To change this template use File | Settings | File Templates.
 */
public final class MultiChoicePanel extends AbstractQuestionPanel
{
  private JRadioButton rbAlternatives[];

  public MultiChoicePanel(ClientToServer connection, MultiChoiceQuestion question,
                          QuestionCategory questionCategory)
  {
    super(connection, question, questionCategory, question.getText());
  }

// --------------------- Begin Interface ActionListener ---------------------

  public void actionPerformed(ActionEvent event)
  {
    if (readOnly)
      return;
    if (event.getSource() == bAnswer) {
      bAnswer.setEnabled(false);
      for (int i = 0; i < rbAlternatives.length; i++)
        if (rbAlternatives[i].isSelected())
          connection.submitStaticAnswer(question.getId(), i);
    }
    else
      bAnswer.setEnabled(true);
  }

// --------------------- End Interface ActionListener ---------------------

  void initAnswerComponents(Question question, GridBagLayout gbl, GridBagConstraints gbc)
  {
    MultiChoiceQuestion mcQuestion = (MultiChoiceQuestion)question;
    rbAlternatives = new JRadioButton[mcQuestion.getAlternatives().length];
    ButtonGroup bg = new ButtonGroup();
    gbc.weighty = 0.0;
    gbc.fill = GridBagConstraints.HORIZONTAL;
    for (int i = 0; i < rbAlternatives.length; i++) {
      rbAlternatives[i] = new JRadioButton("<html>" + mcQuestion.getAlternatives()[i] + "</html>");
      bg.add(rbAlternatives[i]);
      rbAlternatives[i].addActionListener(this);
      gbl.setConstraints(rbAlternatives[i], gbc);
      add(rbAlternatives[i]);
    }
    bAnswer.setEnabled(false);
  }

  void initReadOnlyComponents(Question question, GridBagLayout gbl, GridBagConstraints gbc)
  {
    MultiChoiceQuestion mcQuestion = (MultiChoiceQuestion)question;
    gbc.weighty = 0.0;
    gbc.fill = GridBagConstraints.HORIZONTAL;
    for (int i = 0; i < mcQuestion.getAlternatives().length; i++) {
      JLabel label = new JLabel("Alternativ " + (i + 1) + ": " + mcQuestion.getAlternatives()[i]);
      gbl.setConstraints(label, gbc);
      add(label);
    }
  }
}

