package aoc3.dark;

import javax.swing.*;
import javax.swing.event.*;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Erik Axel Nielsen <erikaxel@stud.ntnu.no>
 * @version 05.jun.2004
 */
final class DarkCodeListModel implements ListModel
{
  private final List<ListDataListener> listeners = new ArrayList<ListDataListener>();
  private String[] sourceLines;

  DarkCodeListModel()
  {
    setSource("");
  }

// --------------------- Begin Interface ListModel ---------------------

  public int getSize()
  {
    return sourceLines.length;
  }

  public Object getElementAt(int index)
  {
    return sourceLines[index];
  }

  public void addListDataListener(ListDataListener l)
  {
    listeners.add(l);
  }

  public void removeListDataListener(ListDataListener l)
  {
    listeners.remove(l);
  }

// --------------------- End Interface ListModel ---------------------

  public void setSource(String source)
  {
    source = source.replaceAll("\\t", "                    ");
    sourceLines = source.split("\n");
    for (ListDataListener listener : listeners)
      listener.contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, sourceLines.length));
  }
}

