package aoc3.dark.architecture;

import java.io.IOException;

/**
 * @author Erik Axel Nielsen <erikaxel@stud.ntnu.no>
 * @version 05.jun.2004
 */
public abstract class AbstractParser
{
  protected InstructionMemory instructionMemory;
  protected final Mem mem;
  protected Run run;
  protected final SymbolTable st;

  protected AbstractParser(Mem mem)
  {
    st = SymbolTable.getInstance();
    this.mem = mem;
    instructionMemory = new InstructionMemory();
  }

  public void setRun(Run run)
  {
    this.run = run;
    instructionMemory = run.instructionMemory;
  }

  protected static void parse_error(String s) throws ParseException
  {
    throw new ParseException(s);
  }

  // TODO: Det skal ikke v�re n�dvendig med en boolean.
  // Burde prøve å fikse til throw etterhvert.
  // Dessuten burde vel strengt tatt IOexception ikke skje....
  public abstract boolean parse() throws ParseException, IOException;
}

