/*
 * The entries in the symbol table
 */
package aoc3.dark.architecture;


/**
 * An instruction - entry in text memory
 */
public final class Instruction
{
  public boolean stop;

  public final int opCode;
  public int data;
  public final int line;

  public Instruction(int op, int d, int l)
  {
    opCode = op;
    data = d;
    line = l;
    stop = false;
  }

  /**
   * print the symbol on screen for debugging purposes.
   */
  public void dump()
  {
    System.out.print("Op: " + opCode + " (" + Inte.names[opCode] + ')');
    System.out.print("\tD: " + data);
    System.out.println("\tline: " + line);
  }
}

