package aoc3.dark.architecture;

import java.util.ArrayList;
import java.util.List;

//
// Classes used for building the instruction memory
//=========================================================


public final class InstructionMemory
{
  /**
   * Vector, where the instrs are stored.
   */
  private final List<Instruction> instrs = new ArrayList<Instruction>();

  InstructionMemory()
  {
  }

  /**
   * Add an instruction to instruction memory
   *
   * @param i
   */
  public int add(Instruction i)
  {
    instrs.add(i);
    return instrs.size() - 1;
  }

  /**
   * dump the instruction memory
   */
  public void dump()
  {
    for (int i = 0; i < instrs.size(); i++) {
      System.out.print(i + ":\t");
      instrs.get(i).dump();
    }
  }

  /**
   * Remove everything from instruction memory
   */
  public void empty()
  {
    instrs.clear();
  }

  /**
   * Get a symbol from the instruction memory
   *
   * @param i
   */
  public Instruction getInstr(int i)
  {
    return instrs.get(i);
  }

  /**
   * Add next avaiable address in instruction memory
   */
  public int next()
  {
    return instrs.size();
  }
}

