/*
 * The entries in the symbol table
 */
package aoc3.dark.architecture;

import java.util.ArrayList;
import java.util.List;

/**
 * A symbol - entry in symbol-table
 */
public final class Symbol
{
  /**
   * The identifier-string from the source-code
   */
  public final String identifier;

  /**
   * Where it is stored (address)
   */
  public List<Integer> updates = new ArrayList<Integer>();

  /**
   * What type is it: procedure, type, signal, ...
   */
  public int kind;

  /**
   * Where it is stored (address)
   */
  public int where;

  public Symbol(String id, int k, int pos)
  {
    identifier = id;
    kind = k;
    where = pos;
  }

  /**
   * print the symbol on screen for debugging purposes.
   */
  public void dump()
  {
    System.out.print("identifier: " + identifier);
    System.out.print("\tkind: " + kind);
    System.out.println("\twhere: " + where);
  }
}

