package aoc3.dark.validation;

import aoc3.dark.architecture.Architecture;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * @author Erik Axel Nielsen <erikaxel@stud.ntnu.no>
 * @version 09.jun.2004
 */
final class StackTest extends Test
{
  StackTest(Architecture arch, Element elem)
  {
    super(arch, elem);
  }

  protected void checkValues() throws ValidationException
  {
    NodeList pops = elem.getElementsByTagName("Pop");
    for (int i = 0; i < pops.getLength(); i++) {
      Element element = (Element)pops.item(i);
      int value = Integer.parseInt(element.getAttribute("value"));
      popValue(value);
    }
  }

  private boolean popValue(int value) throws ValidationException
  {
    if (regs[31] >= 1024) {
      regs[31] = 1023;
      throw new ValidationException(this, "Stack underflyt ved validering..");
    }
    else if (regs[31] < 0) {
      regs[31] = 0;
      throw new ValidationException(this, "Stack overflyt ved validering..");
    }

    int val = getMemoryValue(regs[31]);
    regs[31]++;
    if (val != value)
      throw new ValidationException(this, "Expected " + value + " but got " + val);
    return true;
  }

  private void pushValue(int value)
  {
    regs[31]--; // regs[31] is the stack pointer
    setMemoryValue(regs[31], value);
  }

  protected void setUp()
  {
    regs = architecture.getRun().regs;
    NodeList pushes = elem.getElementsByTagName("Push");
    for (int i = 0; i < pushes.getLength(); i++) {
      Element element = (Element)pushes.item(i);
      int val = Integer.parseInt(element.getAttribute("value"));
      pushValue(val);
    }
  }
}

