package aoc3.dark.validation;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * @author Erik Axel Nielsen <erikaxel@stud.ntnu.no>
 * @version 10.jun.2004
 */
public final class ValidationException extends Exception
{
  private final String validationMsg;

  public ValidationException(String msg)
  {
    super(msg);
    validationMsg = msg;
  }

  public ValidationException(LoadTest test, String msg)
  {
    StringBuilder sb = new StringBuilder();
    sb.append("Fikk feil under validering.\n");
    sb.append("Input: ");

    NodeList regSets = test.elem.getElementsByTagName("RegSet");
    for (int i = 0; i < regSets.getLength(); i++) {
      Element elem = (Element)regSets.item(i);
      String value = elem.getAttribute("value");
      String reg = elem.getAttribute("reg");

      sb.append("reg[").append(reg).append("] = ").append(value);
      if (i == regSets.getLength() - 1)
        sb.append('\n');
      else
        sb.append(", ");
    }
    NodeList memSets = test.elem.getElementsByTagName("MemSet");
    for (int i = 0; i < memSets.getLength(); i++) {
      Element elem = (Element)memSets.item(i);
      String value = elem.getAttribute("value");
      String addr = elem.getAttribute("addr");

      sb.append("mem[").append(addr).append("] = ").append(value);
      if (i == regSets.getLength() - 1)
        sb.append("\n\n");
      else
        sb.append(", ");
    }


    sb.append(msg);
    validationMsg = sb.toString();
  }

  public ValidationException(StackTest test, String msg)
  {
    StringBuilder sb = new StringBuilder();
    sb.append("Fikk feil under validering.\n");
    sb.append("Input: ");
    NodeList pushes = test.elem.getElementsByTagName("Push");
    for (int i = 0; i < pushes.getLength(); i++) {
      Element elem = (Element)pushes.item(i);
      sb.append(elem.getAttribute("value"));
      if (i == pushes.getLength() - 1)
        sb.append("\n\n");
      else
        sb.append(", ");
    }

    sb.append(msg);
    validationMsg = sb.toString();
  }

  public String getValidationMsg()
  {
    return validationMsg;
  }
}

