package aoc3.db;

import bsh.EvalError;
import bsh.Interpreter;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:39:35
 * To change this template use File | Settings | File Templates.
 */
public final class AutoGenQuestion extends Question
{
  private final transient String code;
  private final String formula;

  public AutoGenQuestion(int id, int questionCategoryID, String text, int value, String code, String formula)
  {
    super(id, questionCategoryID, text, value);
    this.code = code;
    this.formula = formula;
  }

  public String getFormula()
  {
    return formula;
  }

  public AutoGenQuestionGenerator makeQuestionGenerator()
  {
    Interpreter i = new Interpreter();
    try {
      i.eval(code);
      return (AutoGenQuestionGenerator)i.eval("return (aoc3.db.AutoGenQuestionGenerator)this");
    } catch (EvalError evalError) {
      evalError.printStackTrace();
      return null;
    }
  }
}
