package aoc3.db;

import bsh.EvalError;
import bsh.Interpreter;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:39:13
 * To change this template use File | Settings | File Templates.
 */
public final class DarkQuestion extends Question
{
  private final transient String code;
  private final String testCode;
  private final transient String suggestedSolution;

  public DarkQuestion(int id, int questionCategoryID, String text, int value, String code, String testCode, String suggestedSolution)
  {
    super(id, questionCategoryID, text, value);
    this.code = code;
    this.testCode = testCode;
    this.suggestedSolution = suggestedSolution;
  }

  public String getCode()
  {
    return code;
  }

  public String getTestCode()
  {
    return testCode;
  }

  public String getSuggestedSolution()
  {
    return suggestedSolution;
  }

  public DarkQuestionGenerator makeQuestionGenerator()
  {
    Interpreter i = new Interpreter();
    try {
      i.eval(code);
      return (DarkQuestionGenerator)i.eval("return (aoc3.db.DarkQuestionGenerator)this");
    } catch (EvalError evalError) {
      System.out.println(code);
      evalError.printStackTrace();
      return null;
    }
  }
}
