package aoc3.db;

import java.sql.*;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:32:40
 * To change this template use File | Settings | File Templates.
 */
public final class Message extends LevelItem
{
  private final String text;
  private final int id;

  static void readPosts(Statement statement, Map<Integer, List<LevelItem>> posts) throws SQLException
  {
    ResultSet rs = statement.executeQuery("SELECT id, text, levelid, posx, posy, posz FROM Message");
    while (rs.next()) {
      int levelID = rs.getInt(3);
      Message post = new Message(rs.getInt(1), rs.getString(2), levelID,
                                 rs.getInt(4), rs.getInt(5), rs.getInt(6));
      List<LevelItem> messages = posts.get(levelID);
      if (messages == null) {
        messages = new ArrayList<LevelItem>();
        posts.put(levelID, messages);
      }
      messages.add(post);
    }
    rs.close();
  }

  private Message(int id, String text, int levelid, int posx, int posy, int posz)
  {
    super(levelid, posx, posy, posz);
    this.id = id;
    this.text = text;
  }

  public String getText()
  {
    return text;
  }
}

