package aoc3.db;

import java.io.Serializable;
import java.sql.*;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:38:45
 * To change this template use File | Settings | File Templates.
 */
public abstract class Question implements Serializable, Comparable
{
  private final String text;
  private final int id;
  private final int questionCategoryID;
  private final int value;

//  static Question readPost(Statement statement, int id) throws SQLException
//  {
//    Question question = null;
//
//    // AutoGenQuestions
//    ResultSet rs = statement.executeQuery("SELECT a.id, q.questioncategoryid, q.text, q.value, a.code, a.formula " +
//                                          "FROM Question q, AutoGenQuestion a WHERE a.id = q.id AND q.id = " + id);
//    if (rs.next())
//      question = new AutoGenQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
//                                     rs.getInt(4), rs.getString(5), rs.getString(6));
//    rs.close();
//
//    // DarkQuestions
//    rs = statement.executeQuery("SELECT d.id, q.questioncategoryid, q.text, q.value, d.code, d.TestCode, d.SuggestedSolution " +
//                                "FROM Question q, DarkQuestion d WHERE d.id = q.id AND q.id = " + id);
//    if (rs.next())
//      question = new DarkQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
//                                  rs.getInt(4), rs.getString(5), rs.getString(6), rs.getString(7));
//    rs.close();
//
//    // InputQuestions
//    rs = statement.executeQuery("SELECT i.id, q.questioncategoryid, q.text, q.value, i.answer " +
//                                "FROM Question q, InputQuestion i WHERE i.id = q.id AND q.id = " + id);
//    if (rs.next())
//      question = new InputQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
//                                   rs.getInt(4), rs.getString(5));
//    rs.close();
//
//    rs = statement.executeQuery("SELECT m.id, q.questioncategoryid, q.text, q.value, m.answerid, MAX(a.alternativeid) " +
//                                "FROM Question q, MultiChoiceQuestion m, MultiChoiceAlternative a " +
//                                "WHERE m.id = q.id AND a.questionid = m.id AND q.id = " + id + " GROUP BY m.id");
//    if (rs.next()) {
//      question = new MultiChoiceQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
//                                         rs.getInt(4), rs.getInt(5), rs.getInt(6) + 1);
//      rs.close();
//      rs = statement.executeQuery("SELECT QuestionID, AlternativeID, Text FROM MultiChoiceAlternative " +
//                                  "WHERE QuestionID = " + id);
//      while (rs.next()) {
//        MultiChoiceQuestion mcq = (MultiChoiceQuestion)question;
//        mcq.setAlternative(rs.getInt(2), rs.getString(3));
//      }
//    }
//    rs.close();
//
//    return question;
//  }

  static void readPosts(Statement statement, Map<Integer, Question> posts) throws SQLException
  {
    // AutoGenQuestions
    ResultSet rs = statement.executeQuery("SELECT a.id, q.questioncategoryid, q.text, q.value, a.code, a.formula " +
                                          "FROM Question q, AutoGenQuestion a WHERE a.id = q.id");
    while (rs.next()) {
      Question question = new AutoGenQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
                                              rs.getInt(4), rs.getString(5), rs.getString(6));
      posts.put(question.getId(), question);
    }
    rs.close();

    // DarkQuestions
    rs = statement.executeQuery("SELECT d.id, q.questioncategoryid, q.text, q.value, d.code, d.TestCode, d.SuggestedSolution " +
                                "FROM Question q, DarkQuestion d WHERE d.id = q.id");
    while (rs.next()) {
      Question question = new DarkQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
                                           rs.getInt(4), rs.getString(5), rs.getString(6), rs.getString(7));
      posts.put(question.getId(), question);
    }
    rs.close();

    // InputQuestions
    rs = statement.executeQuery("SELECT i.id, q.questioncategoryid, q.text, q.value, i.answer " +
                                "FROM Question q, InputQuestion i WHERE i.id = q.id");
    while (rs.next()) {
      Question question = new InputQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
                                            rs.getInt(4), rs.getString(5));
      posts.put(question.getId(), question);
    }
    rs.close();

    // MultiChoiceQuestions
    rs = statement.executeQuery("SELECT m.id, q.questioncategoryid, q.text, q.value, m.answerid, MAX(a.alternativeid) " +
                                "FROM Question q, MultiChoiceQuestion m, MultiChoiceAlternative a " +
                                "WHERE m.id = q.id AND a.questionid = m.id GROUP BY m.id");
    while (rs.next()) {
      Question question = new MultiChoiceQuestion(rs.getInt(1), rs.getInt(2), rs.getString(3),
                                                  rs.getInt(4), rs.getInt(5), rs.getInt(6) + 1);
      posts.put(question.getId(), question);
    }
    rs.close();
    rs = statement.executeQuery("SELECT QuestionID, AlternativeID, Text FROM MultiChoiceAlternative");
    while (rs.next()) {
      MultiChoiceQuestion mcq = (MultiChoiceQuestion)posts.get(rs.getInt(1));
      mcq.setAlternative(rs.getInt(2), rs.getString(3));
    }
  }

  protected Question(int id, int questionCategoryID, String text, int value)
  {
    this.id = id;
    this.questionCategoryID = questionCategoryID;
    this.text = text;
    this.value = value;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(Object o)
  {
    Question q = (Question)o;
    return getId() - q.getId();
  }

// --------------------- End Interface Comparable ---------------------

  public String toString()
  {
    return String.valueOf(getId());
  }

  public int getId()
  {
    return id;
  }

  public int getQuestionCategoryID()
  {
    return questionCategoryID;
  }

  public String getText()
  {
    return text;
  }

  public int getValue()
  {
    return value;
  }
}

