package aoc3.db;

import java.sql.*;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:33:02
 * To change this template use File | Settings | File Templates.
 */
public final class QuestionCategory extends LevelItem implements Comparable
{
  private final String name;
  private final String description;
  private final String text;
  private final int id;
  private final int questiongroupid;
  private final int questionsrequired;

  static void readPosts(Statement statement, Map<Integer, QuestionCategory> posts) throws SQLException
  {
    ResultSet rs = statement.executeQuery("SELECT id, questiongroupid, name, description, text, " +
                                          "questionsrequired, levelid, posx, posy, posz FROM QuestionCategory");
    while (rs.next()) {
      QuestionCategory post = new QuestionCategory(rs.getInt(1), rs.getInt(2), rs.getString(3),
                                                   rs.getString(4), rs.getString(5), rs.getInt(6),
                                                   rs.getInt(7), rs.getInt(8), rs.getInt(9), rs.getInt(10));
      posts.put(post.getId(), post);
    }
    rs.close();
  }

  private QuestionCategory(int id, int questiongroupid, String name, String description, String text,
                           int questionsrequired, int levelid, int posx, int posy, int posz)
  {
    super(levelid, posx, posy, posz);
    this.id = id;
    this.questiongroupid = questiongroupid;
    this.name = name;
    this.description = description;
    this.text = text;
    this.questionsrequired = questionsrequired;
  }

  public String toString()
  {
    return name;
  }

  public int compareTo(Object o)
  {
    return toString().compareToIgnoreCase(o.toString());
  }

  public int getId()
  {
    return id;
  }

  public String getName()
  {
    return name;
  }

  public int getQuestionGroupid()
  {
    return questiongroupid;
  }

  public int getQuestionsrequired()
  {
    return questionsrequired;
  }

  public String getText()
  {
    return text;
  }
}

