package aoc3.db;

import java.io.Serializable;
import java.sql.*;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 09.mai.2005
 * Time: 10:56:25
 * To change this template use File | Settings | File Templates.
 */
public final class QuestionGroup implements Serializable, Comparable
{
  public static final int NO_PARENT = -1;
  private final String name;
  private final String description;
  private final int id;
  private final int parentID;

  static void readPosts(Statement statement, Map<Integer, QuestionGroup> posts) throws SQLException
  {
    ResultSet rs = statement.executeQuery("SELECT id, parentid, name, description FROM QuestionGroup");
    while (rs.next()) {
      int id = rs.getInt(1);
      Integer parentID = (Integer)rs.getObject(2);
      if (parentID == null)
        posts.put(id, new QuestionGroup(id, rs.getString(3), rs.getString(4)));
      else
        posts.put(id, new QuestionGroup(id, parentID, rs.getString(3), rs.getString(4)));
    }
    rs.close();
  }

  private QuestionGroup(int id, String name, String description)
  {
    this.id = id;
    parentID = NO_PARENT;
    this.name = name;
    this.description = description;
  }

  private QuestionGroup(int id, int parentID, String name, String description)
  {
    this.id = id;
    this.parentID = parentID;
    this.name = name;
    this.description = description;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(Object o)
  {
    return toString().compareToIgnoreCase(o.toString());
  }

// --------------------- End Interface Comparable ---------------------

  public String toString()
  {
    return name;
  }

  public int getId()
  {
    return id;
  }

  public int getParentID()
  {
    return parentID;
  }
}

