package aoc3.db;

import java.sql.*;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: Magnus Jahre
 * Date: 20.jul.2006
 * Time: 15:09:20
 * To change this template use File | Settings | File Templates.
 */

public final class Settings
{
  private static final String EXAM_MODE_KEY = "ExamMode";
  private static final String DO_NOT_SHOW_QUESTION_GROUP_KEY = "DoNotShowQuestionGroup";
  private static final String DO_NOT_SHOW_TEXT_GROUP_KEY = "DoNotShowTextGroup";
  private static final String LAST_QUESTION_ID_KEY = "LastQuestionID";

  private final Map<String, String> settings;

  public static Settings readPosts(Statement statement) throws SQLException
  {
    Map<String, String> newSettings = new HashMap<String, String>();
    ResultSet rs = statement.executeQuery("SELECT Name, Value FROM Settings");

    while (rs.next())
      newSettings.put(rs.getString(1), rs.getString(2));
    rs.close();

    return new Settings(newSettings);
  }

  private Settings(Map<String, String> settings)
  {
    this.settings = settings;
  }

  public int getDoNotShowQuestionGroup()
  {
    return Integer.parseInt(settings.get(DO_NOT_SHOW_QUESTION_GROUP_KEY));
  }

  public int getDoNotShowTextGroup()
  {
    return Integer.parseInt(settings.get(DO_NOT_SHOW_TEXT_GROUP_KEY));
  }

  public int getLastQuestionID()
  {
    return Integer.parseInt(settings.get(LAST_QUESTION_ID_KEY));
  }

  public boolean isExamMode()
  {
    return settings.get(EXAM_MODE_KEY).equals("on");
  }
}
