package aoc3.db;

import java.sql.*;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:32:13
 * To change this template use File | Settings | File Templates.
 */
public final class TeleportSource extends LevelItem
{
  private final String text;
  private final int id;
  private final int teleportdestid;

  static void readPosts(Statement statement, Map<Integer, List<LevelItem>> posts) throws SQLException
  {
    ResultSet rs = statement.executeQuery("SELECT id, teleportdestid, text, levelid, posx, posy, posz " +
                                          "FROM TeleportSource");
    while (rs.next()) {
      int levelID = rs.getInt(4);
      TeleportSource post = new TeleportSource(rs.getInt(1), rs.getInt(2), rs.getString(3), levelID,
                                               rs.getInt(5), rs.getInt(6), rs.getInt(7));
      List<LevelItem> sources = posts.get(levelID);
      if (sources == null) {
        sources = new ArrayList<LevelItem>();
        posts.put(levelID, sources);
      }
      sources.add(post);
    }
    rs.close();
  }

  private TeleportSource(int id, int teleportdestid, String text, int levelid, int posx, int posy, int posz)
  {
    super(levelid, posx, posy, posz);
    this.id = id;
    this.teleportdestid = teleportdestid;
    this.text = text;
  }

  public int getId()
  {
    return id;
  }

  public int getTeleportdestid()
  {
    return teleportdestid;
  }

  public String getText()
  {
    return text;
  }
}

