package aoc3.db;

import java.sql.*;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:32:50
 * To change this template use File | Settings | File Templates.
 */
public final class Text extends LevelItem implements Comparable
{
  public static final int TYPE_FACT = 0;
  public static final int TYPE_HISTORY = 1;

  private final String name;
  private final String text;
  private final int type;
  private final int id;
  private final int textGroupID;
  private final int sequence;

//  public static Text readPost(Statement statement, int id) throws SQLException
//  {
//    Text text = null;
//    ResultSet rs = statement.executeQuery("SELECT id, textgroupid, name, text, type, levelid, posx, posy, " +
//                                          "posz, sequence " +
//                                          "FROM Text WHERE id = " + id);
//    if (rs.next())
//      text = new Text(rs.getInt(1), rs.getInt(2), rs.getString(3), rs.getString(4), rs.getString(5),
//                      rs.getInt(6), rs.getInt(7), rs.getInt(8), rs.getInt(9), rs.getInt(10));
//    rs.close();
//    return text;
//  }

  static void readPosts(Statement statement, Map<Integer, Text> posts) throws SQLException
  {
    ResultSet rs = statement.executeQuery("SELECT id, textgroupid, name, text, type, levelid, posx, posy, " +
                                          "posz, sequence " +
                                          "FROM Text");
    while (rs.next()) {
      Text text = new Text(rs.getInt(1), rs.getInt(2), rs.getString(3), rs.getString(4), rs.getString(5),
                           rs.getInt(6), rs.getInt(7), rs.getInt(8), rs.getInt(9), rs.getInt(10));
      posts.put(text.getId(), text);
    }
    rs.close();
  }

  private Text(int id, int textGroupID, String name, String text, String type,
               int levelid, int posx, int posy, int posz, int sequence)
  {
    super(levelid, posx, posy, posz);
    this.id = id;
    this.textGroupID = textGroupID;
    this.name = name;
    this.text = text;
    if (type.equalsIgnoreCase("fact"))
      this.type = TYPE_FACT;
    else
      this.type = TYPE_HISTORY;
    this.sequence = sequence;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(Object o)
  {
    Text t = (Text)o;
    return getSequence() - t.getSequence();
  }

// --------------------- End Interface Comparable ---------------------

  public String toString()
  {
    return name;
  }

  public int getId()
  {
    return id;
  }

  public String getName()
  {
    return name;
  }

  private int getSequence()
  {
    return sequence;
  }

  public String getText()
  {
    return text;
  }

  public int getTextGroupID()
  {
    return textGroupID;
  }

  public int getType()
  {
    return type;
  }
}

