package aoc3.db;

import java.io.Serializable;
import java.sql.*;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 09.mai.2005
 * Time: 10:52:58
 * To change this template use File | Settings | File Templates.
 */
public final class TextGroup implements Serializable, Comparable
{
  public static final int FACT_ROOT_ID = 1000;
  public static final int HISTORY_ROOT_ID = 1001;
  private final String name;
  private final String text;
  private final int id;
  private final int parentID;
  private final int sequence;

  static void readPosts(Statement statement, Map<Integer, TextGroup> posts) throws SQLException
  {
    ResultSet rs = statement.executeQuery("SELECT id, parentid, name, text, sequence FROM TextGroup");
    while (rs.next()) {
      int id = rs.getInt(1);
      posts.put(id, new TextGroup(id, rs.getInt(2), rs.getString(3), rs.getString(4), rs.getInt(5)));
    }
    rs.close();
  }

  private TextGroup(int id, int parentID, String name, String text, int sequence)
  {
    this.id = id;
    this.parentID = parentID;
    this.name = name;
    this.text = text;
    this.sequence = sequence;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(Object o)
  {
    TextGroup tg = (TextGroup)o;
    return getSequence() - tg.getSequence();
  }

// --------------------- End Interface Comparable ---------------------

  public String toString()
  {
    return name;
  }

  public int getId()
  {
    return id;
  }

  public int getParentID()
  {
    return parentID;
  }

  private int getSequence()
  {
    return sequence;
  }
}

