package aoc3.db;

import java.io.Serializable;
import java.sql.*;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:40:10
 * To change this template use File | Settings | File Templates.
 */
public final class User implements Serializable
{
  private static transient PreparedStatement updatePost;
  private final int id;
  private final String username;
  private final transient String password; // Transient => Sendes ikke over nett
  private final boolean admin;
  private final int avatar;
  private int levelid;
  private int posx;
  private int posy;
  private int posz;

  static User readPost(Statement statement, String username) throws SQLException
  {
    User user = null;
    ResultSet rs = statement.executeQuery("SELECT id, username, password, admin, avatar, " +
                                          "levelid, posx, posy, posz " +
                                          "FROM User WHERE username = '" + username + '\'');
    if (rs.next()) {

      user = new User(rs.getInt(1), rs.getString(2), rs.getString(3), rs.getInt(4) == 1,
                      rs.getInt(5), rs.getInt(6), rs.getInt(7), rs.getInt(8), rs.getInt(9));
    }
    return user;
  }

  static void readPosts(Statement statement, List<User> posts) throws SQLException
  {
    updatePost = statement.getConnection().prepareStatement("UPDATE User SET levelid = ?, posx = ?, " +
                                                            "posy = ?, posz = ? WHERE id = ?");

    ResultSet rs = statement.executeQuery("SELECT id, username, password, admin, avatar, " +
                                          "levelid, posx, posy, posz " +
                                          "FROM User");
    while (rs.next()) {

      posts.add(new User(rs.getInt(1), rs.getString(2), rs.getString(3), rs.getInt(4) == 1,
                         rs.getInt(5), rs.getInt(6), rs.getInt(7), rs.getInt(8), rs.getInt(9)));
    }
    rs.close();
  }

  private User(int id, String username, String password, boolean admin, int avatar, int levelid, int posx, int posy, int posz)
  {
    this.id = id;
    this.username = username;
    this.password = password;
    this.admin = admin;
    this.avatar = avatar;
    this.levelid = levelid;
    this.posx = posx;
    this.posy = posy;
    this.posz = posz;
  }

  public String getUsername()
  {
    return username;
  }

  public int getId()
  {
    return id;
  }

  public String getPassword()
  {
    return password;
  }

  public boolean isAdmin()
  {
    return admin;
  }

  public int getAvatar()
  {
    return avatar;
  }

  public int getLevelid()
  {
    return levelid;
  }

  public int getPosx()
  {
    return posx;
  }

  public int getPosy()
  {
    return posy;
  }

  public int getPosz()
  {
    return posz;
  }

  public String toString()
  {
    return username;
  }

  public void moveTo(int posx, int posy)
  {
    this.posx = posx;
    this.posy = posy;
  }

  public void moveTo(int levelid, int posx, int posy, int posz)
  {
    this.levelid = levelid;
    this.posx = posx;
    this.posy = posy;
    this.posz = posz;
  }

  void makeUpdatesPersistent() throws SQLException
  {
    updatePost.setInt(1, levelid);
    updatePost.setInt(2, posx);
    updatePost.setInt(3, posy);
    updatePost.setInt(4, posz);
    updatePost.setInt(5, id);
    updatePost.executeUpdate();
  }
}
