package aoc3.db;

import java.sql.*;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 08.mai.2005
 * Time: 13:23:53
 * To change this template use File | Settings | File Templates.
 */
final class UserText
{
  private static PreparedStatement insertPost;
  private final int userID;
  private final int textID;

  static void readPosts(Statement statement, Map<Integer, List<UserText>> posts) throws SQLException
  {
    insertPost = statement.getConnection().prepareStatement("INSERT INTO UserText(userid, textid) " +
                                                            "VALUES (?,?)");

    ResultSet rs = statement.executeQuery("SELECT userid, textid FROM UserText");
    while (rs.next()) {
      int userID = rs.getInt(1);
      int textID = rs.getInt(2);
      UserText post = new UserText(userID, textID);
      List<UserText> userTexts = posts.get(userID);
      if (userTexts == null) {
        userTexts = new ArrayList<UserText>();
        posts.put(userID, userTexts);
      }
      userTexts.add(post);
    }
  }

  UserText(int userID, int textID)
  {
    this.userID = userID;
    this.textID = textID;
  }

  public int getTextID()
  {
    return textID;
  }

  void makePostPersistent() throws SQLException
  {
    insertPost.setInt(1, userID);
    insertPost.setInt(2, textID);
    insertPost.executeUpdate();
  }
}
