package aoc3.event;

import aoc3.db.User;

import java.io.Serializable;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 12.apr.2005
 * Time: 17:30:58
 * To change this template use File | Settings | File Templates.
 */
public final class LoginEvent implements Serializable
{
  public static final int LOGIN_SUCCESS = 0;
  public static final int LOGIN_WRONG_PASSWORD = 1;
  public static final int LOGIN_UNKNOWN_USER = 2;
  public static final int LOGIN_ALREADY_LOGGED_ON = 3;
  public static final int LOGIN_ERROR = 4;

  private final User user;
  private final int type;
  private final int score;

  public LoginEvent(int type)
  {
    this.type = type;
    user = null;
    score = 0;
  }

  public LoginEvent(int type, User user, int score)
  {
    this.type = type;
    this.user = user;
    this.score = score;
  }

  public int getType()
  {
    return type;
  }

  public User getUser()
  {
    return user;
  }

  public int getScore()
  {
    return score;
  }
}

