package aoc3.event;

import aoc3.db.*;

import java.io.Serializable;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 06.jul.2005
 * Time: 15:57:29
 * To change this template use File | Settings | File Templates.
 */
public final class QuestionEvent implements Serializable
{
  private final Question question;
  private final QuestionCategory questionCategory;
  private final String darkTestSet;
  private final String darkTestCode;
  private final String autoGenQuestionText;

  private QuestionEvent(Question question, QuestionCategory questionCategory, String autoGenQuestionText, String darkTestSet, String darkTestCode)
  {
    this.question = question;
    this.questionCategory = questionCategory;
    this.darkTestSet = darkTestSet;
    this.autoGenQuestionText = autoGenQuestionText;
    this.darkTestCode = darkTestCode;
  }

  public QuestionEvent(Question question, QuestionCategory questionCategory)
  {
    this(question, questionCategory, null, null, null);
  }

  public QuestionEvent(AutoGenQuestion question, QuestionCategory questionCategory, String autoGenQuestionText)
  {
    this(question, questionCategory, autoGenQuestionText, null, null);
  }

  public QuestionEvent(DarkQuestion question, QuestionCategory questionCategory, String darkTestSet, String darkTestCode)
  {
    this(question, questionCategory, null, darkTestSet, darkTestCode);
  }

  public Question getQuestion()
  {
    return question;
  }

  public QuestionCategory getQuestionCategory()
  {
    return questionCategory;
  }

  public String getDarkTestSet()
  {
    return darkTestSet;
  }

  public String getAutoGenQuestionText()
  {
    return autoGenQuestionText;
  }

  public String getDarkTestCode()
  {
    return darkTestCode;
  }
}
