package aoc3.net;

import aoc3.event.*;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:29:56
 * To change this template use File | Settings | File Templates.
 */
public interface ClientToServer
{
  void startListening();

  // Chat
  void fireRemoteChatEvent(ChatEvent event);

  void addChatListener(ChatEventListener listener);

  void removeChatListener(ChatEventListener listener);

  // Login
  void requestLogin(String username, String password);

  void logout();

  void addLoginListener(LoginEventListener listener);

  void removeLoginListener(LoginEventListener listener);

  // HTML
  void addHTMLListener(HTMLEventListener listener);

  void removeHTMLListener(HTMLEventListener listener);

  // Users
  void notifyMove(int posx, int posy);

  void addUserListener(UserEventListener listener);

  void removeUserListener(UserEventListener listener);

  void addPositionChangeListener(PositionChangeListener listener);

  void removePositionChangeListener(PositionChangeListener listener);

  // Question
  void addQuestionListener(QuestionEventListener listener);

  void removeQuestionListener(QuestionEventListener listener);

  void submitStaticAnswer(int id, Object answer);

  void submitAutogenAnswer(int id, String answer);

  void submitDarkAnswer(int id, String answer);

  void addAnswerEventListener(AnswerEventListener listener);

  void removeAnswerEventListener(AnswerEventListener listener);

  // Levels
  void requestLevel(int id);

  void addLevelListener(LevelEventListener listener);

  void removeLevelListener(LevelEventListener listener);

  // Books
  void requestBookText(int type);

  void requestBookQuestion();

  void addTextBookListener(TextBookListener listener);

  void removeTextBookListener(TextBookListener listener);

  void addQuestionBookListener(QuestionBookListener listener);

  void removeQuestionBookListener(QuestionBookListener listener);
}
