package aoc3.net;

import aoc3.db.*;
import aoc3.event.*;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: Jon Olav Hauglid
 * Date: 10.apr.2005
 * Time: 14:30:23
 * To change this template use File | Settings | File Templates.
 */
interface ServerToClient
{
  // Chat
  void fireRemoteChatEvent(ChatEvent event); // Både egen og andres tråd

  void addChatListener(ChatEventListener listener);

  void removeChatListener(ChatEventListener listener);

  // Login
  void fireLoginEvent(LoginEvent event) throws IOException; // Egen tråd

  boolean passwordMatches(String actualPassword, byte[] suppliedKey);

  void disconnect(); // Egen tråd

  // HTML
  void fireTextEvent(Text text) throws IOException; // Egen tråd

  // Users
  void fireUserEvent(UserEvent event); // Både egen og andres tråd

  void firePositionChange(int userID, int posx, int posy); // Andres tråd

  void fireLevelChange(int userID, int levelID, int posx, int posy, int posz); // Både egen og andres tråd

  // Questions
  void fireQuestionEvent(QuestionEvent event) throws IOException; // Egen tråd

  void fireAnswerEvent(boolean wasCorrect, boolean canRetry, int newScore) throws IOException; // Egen tråd

  // Levels
  void fireLevelEvent(Level level, Map<Integer, List<LevelItem>> levelItems) throws IOException; // Egen tråd

  void fireLevelEvent(LevelItem levelItem) throws IOException; // Egen tråd

  void fireLevelEvent(LevelItem levelItem, Integer newAnimNr) throws IOException; // Egen tråd

  // Books
  void fireBookEvent(int type, List<Text> visitedTexts, Map<Integer, TextGroup> textGroups) throws IOException; // Egen tråd

  void fireBookEvent(Map<UserQuestion, Question> completedQuestions,
                     Map<Integer, QuestionCategory> questionCategories,
                     Map<Integer, QuestionGroup> questionGroups,
                     Map<UserQuestion, String> autogenQuestionTexts,
                     Map<UserQuestion, String> autogenFormulas,
                     Map<UserQuestion, String> darkSuggestedSolutions) throws IOException; // Egen tråd
}
