package gui;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * The panel containing the button(s) at the bottom of
 * the editor view.
 *
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class ButtonPanel extends JPanel implements ActionListener {
    private JButton discard;
    private JButton save;
    private Saver saver;

    public ButtonPanel(Saver saver) {
        this.saver = saver;
        this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        this.discard = new JButton("Discard");
        this.discard.addActionListener(this);
        this.save = new JButton("Save");
        this.save.addActionListener(this);

        this.add(Box.createHorizontalGlue());
        this.add(save);
        this.add(discard);
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(save)) saver.saveButtonPressed();
        else if (e.getSource().equals(discard)) saver.discardButtonPressed();
    }
}
