package gui;

/**
 * A class implementing the Saver interface handles when
 * save- or discard buttons are clicked. 
 *
 * @author Tarje Killingberg - 14.jul.2006
 * @see AdminPanel
 * @see gui.tabs.AbstractTab
 */
public interface Saver {
    /**
     * Invoked when the global save-button has been pressed.
     * Should save all changed objects to database
     */
    public void saveButtonPressed();

    /**
     * Invoked when the global discard-button has been pressed.
     * Should discard all discardable information of the currently selected object.
     */
    public void discardButtonPressed();
}
