package gui;

import sys.AoCAdmin;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;

/**
 * Displays a text string showing the current state of the application (the
 * selected view). Is updated whenever the user changes between Editor- and Admin
 * view, between the editors, or object type in the tree.
 *
 * @author Tarje Killingberg - 20.jun.2006
 */
public class StatusBar extends JPanel {
    private JLabel statusLabel;
    public StatusBar() {
        setLayout(new BorderLayout());

        JPanel dbConnection = createStatusBarElement(new JLabel("<html><b>DB:</b> " + AoCAdmin.DATABASE_SERVER + "</html>"));
        JPanel webConnection = createStatusBarElement(new JLabel("<html><b>Web:</b> " + AoCAdmin.WEB_SERVER + "</html>"));

        JPanel connections = new JPanel(new GridLayout(1, 1));

        connections.add(dbConnection);
        connections.add(webConnection);

        this.add(connections, BorderLayout.WEST);

        JPanel empty = createStatusBarElement(new JLabel());
        add(empty, BorderLayout.CENTER);

        statusLabel = new JLabel("Unknown");
        JPanel statusPanel = createStatusBarElement(statusLabel);
        add(statusPanel, BorderLayout.EAST);
    }

    public void setText(String status) {
        statusLabel.setText(status);
    }

    private JPanel createStatusBarElement(JLabel element) {
        element.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 5));
        JPanel parent = new JPanel(new GridLayout(1, 1));
        parent.setBorder(BorderFactory.createLoweredBevelBorder());
        parent.add(element);
        return parent;
    }

    public void setStatus(ArrayList<String> status) {
        String s = "<html>";

        for (int i = 0; i < status.size(); i++) {
            s += status.get(i);

            if (i < status.size() - 1) s += " : ";
        }

        s += "</html>";

        this.statusLabel.setText(s);
    }
}
