package gui;

import java.lang.reflect.Method;

/**
 * @author Eivind Sorteberg - 03.aug.2006
 */
public class URLHandler {
    /**
     * Method used to open URL's in the system's default browser.
     * Code found at http://www.centerkey.com/java/browser/
     *
     * @param url The url of the web site to display
     */
    public static void openURL(String url) {
        String osName = System.getProperty("os.name");

        try {
            if (osName.startsWith("Mac OS")) {
                Class fileMgr = Class.forName("com.apple.eio.FileManager");
                Method openURL = fileMgr.getDeclaredMethod("openURL", String.class);
                openURL.invoke(null, url);
            }
            else if (osName.startsWith("Windows"))
                Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + url);
            else { //assume Unix or Linux
                String[] browsers = {
                "firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape" };
                String browser = null;

                for (int count = 0; count < browsers.length && browser == null; count++) {

                    if (Runtime.getRuntime().exec(new String[] {"which", browsers[count]}).waitFor() == 0) {
                        browser = browsers[count];
                    }
                }
                if (browser == null) System.err.println("Could not find web browser");

                else Runtime.getRuntime().exec(new String[] {browser, url});
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
