package gui.editors.common;

import javax.swing.*;

/**
 * A JPanel which can be set to uneditable when needed.
 * Implemented by all objectpanels of the application.
 *
 * @author Eivind Sorteberg - 26.jul.2006
 */
public abstract class DPanel extends JPanel {

    /**
     * Disables all components on the panel, so that their information
     * cannot be updated.
     * Is used to make sure that editable panels always correspond with the currently
     * selected object.
     *
     * @param editable Whether the user should be able to alter the information or not.
     */
    public abstract void setEditable(boolean editable);
}
