package gui.editors.common;

import javax.swing.*;
import java.awt.*;

/**
 * @author Eivind Sorteberg - 19.jul.2006
 */
public class InputPane extends JEditorPane {
    public InputPane(String text, boolean editable) {
        super("text", text);

        this.setEditable(editable);
        this.setFont(new Font("Courier", Font.PLAIN, 12));
    }

    public InputPane(String text) {
        this(text, true);
    }

    public InputPane(boolean editable) {
        this("", editable);
    }

    public InputPane() {
        this("", true);
    }

    public void setText(String t) {
        super.setText(t);
        this.setCaretPosition(0);
    }
}
