package gui.editors.common;

import javax.swing.*;
import java.awt.*;

/**
 * Generates a panel showing the position in the map of
 * the selected object.
 *
 * @author Eivind Sorteberg - 20.jun.2006
 */
public class PlacementPanel extends JPanel {
    private JComboBox levelSelector;
    private JTextField xPos;
    private JTextField yPos;
    private JTextField zPos;
    private JButton changePosition;

    public PlacementPanel(JComboBox levelSelector, JTextField xPos, JTextField yPos, JTextField zPos, JButton move) {
        super();

        this.setBorder(BorderFactory.createTitledBorder("Placement"));

        this.levelSelector = levelSelector;
        this.xPos = xPos;
        this.yPos = yPos;
        this.zPos = zPos;
        this.changePosition = move;

        this.placeComponents();
    }

    private void placeComponents() {
        JPanel level = new JPanel(new BorderLayout());
        level.add(new TitleLabel("Level"), BorderLayout.WEST);
        level.add(levelSelector, BorderLayout.CENTER);

        JPanel position = new JPanel();
        position.setLayout(new BoxLayout(position, BoxLayout.X_AXIS));
        position.add(Box.createHorizontalGlue());
        position.add(new TitleLabel("X "));
        position.add(xPos);
        position.add(new TitleLabel(" Y "));
        position.add(yPos);
        position.add(new TitleLabel(" Z "));
        position.add(zPos);
        position.add(changePosition);
        position.add(Box.createHorizontalGlue());

        this.setLayout(new BorderLayout(0, 2));
        this.add(level, BorderLayout.NORTH);
        this.add(position, BorderLayout.SOUTH);
    }
}
