package gui.editors.common.selector;

import sys.datatypes.Group;
import sys.datatypes.GroupElement;
import sys.models.treemodels.AbstractTreeModel;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

/**
 * This popup shows a list of the possible parents of the selected object.
 * This list is generated by the corresponding model.
 *
 * @author Eivind Sorteberg - 04.jul.2006
 */
public class ParentSelector extends AbstractSelector implements ActionListener {
    public ParentSelector(JPanel parent, AbstractTreeModel model) {
        super(parent, model);
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(ok)) {
            model.moveObject((Group)((JList)selector).getSelectedValue());
        }
        remove();
    }


    /* Methods implemented from AbstractSelector */

    protected JComponent createSelector() {
        ArrayList<Group> parents = model.getPotentialParents((GroupElement)model.getModelManager().getCurrentObject());
        return new JList(parents.toArray());
    }

    protected JComponent getSelectorComponent() {
        return new JScrollPane(selector);
    }

    protected String setTitle() {
        return "Select the new parent group";
    }
}
