package gui.editors.common.selector;

import gui.editors.level.TeleSrcInfo;
import sys.datatypes.GroupElement;
import sys.datatypes.question.QuestionCategory;
import sys.models.treemodels.LevelTreeModel;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
/**
 * This popup shows a list of potential requirements for a TeleportSource.
 *
 * @see TeleSrcInfo
 * @author Tarje Killingberg - 15.jul.2006
 */
public class TeleportSourceRequirementSelector extends AbstractSelector implements ActionListener {
    public TeleportSourceRequirementSelector(TeleSrcInfo parent, LevelTreeModel model) {
        super(parent, model);
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(ok)) {
            ((TeleSrcInfo)parent).addRequirement((QuestionCategory)((JList)selector).getSelectedValue());
        }
        remove();
    }


    /* Methods inherited from AbstractSelector */

    protected JComponent createSelector() {
        ArrayList<QuestionCategory> potentialCategories = ((LevelTreeModel)model).getPotentialTeleportRequirementCategories((GroupElement)model.getModelManager().getCurrentObject());
        return new JList(potentialCategories.toArray());
    }


    protected JComponent getSelectorComponent() {
        return new JScrollPane(selector);
    }


    protected String setTitle() {
        return "Select question category to add to the Teleportsource's requirements";
    }

}