package gui.editors.level;

import gui.editors.common.InfoPanel;
import gui.editors.common.PlacementPanel;
import gui.editors.common.util.InfoPanelGenerator;
import sys.datatypes.History;

import javax.swing.*;
import java.awt.*;

/**
 * The panel containing the information of the currently selected
 * <code>History</code> object, if any.
 *
 * @author Tarje Killingberg - 29.jun.2006
 */
public class HistoryInfo extends InfoPanel {


    private JTextField name;


    public HistoryInfo() {
        super();
        this.setLayout(new BorderLayout());
        this.name = new JTextField();
        InfoPanelGenerator.placeComponents(infoPanel, 3, 1, new Object[]{"Name", name, null});
        this.add(infoPanel, BorderLayout.NORTH);
        PlacementPanel placement = new PlacementPanel(levelBox, xPos, yPos, zPos, changePositionButton);
        this.add(placement, BorderLayout.SOUTH);
    }


    public void showObject(History object) {
        super.showObject(object);
        name.setText(object.getName());
        name.setCaretPosition(0);
    }


    public String getName() {
        return name.getText();
    }

    public void setEditable(boolean editable) {
        super.setMovable(editable);
        this.name.setEnabled(editable);
    }
}
