package gui.editors.level;

import gui.editors.common.InfoPanel;
import gui.editors.common.InfoTextArea;
import gui.editors.common.PlacementPanel;
import gui.editors.common.util.InfoPanelGenerator;
import sys.datatypes.Message;

import javax.swing.*;
import java.awt.*;

/**
 * Contains the information boxes for the selected message
 * in the level editor view.
 *
 * @author Eivind Sorteberg - 23.jun.2006
 */
public class MessageInfo extends InfoPanel {
    private JTextArea text;

    public MessageInfo() {
        super();
        this.setLayout(new BorderLayout());
        this.text = new JTextArea();
        InfoPanelGenerator.placeComponents(infoPanel, 3, 1, new Object[]{"Text", new InfoTextArea(text), null});
        this.add(infoPanel, BorderLayout.NORTH);
        PlacementPanel placement = new PlacementPanel(levelBox, xPos, yPos, zPos, changePositionButton);
        this.add(placement, BorderLayout.SOUTH);
    }


    public void showObject(Message object) {
        super.showObject(object);
        text.setText(object.getText());
        text.setCaretPosition(0);
    }


    public String getText() {
        return text.getText();
    }

    public void setEditable(boolean editable) {
        super.setMovable(editable);
        this.text.setEnabled(editable);
    }
}