package gui.editors.question.question;

import gui.editors.common.DPanel;
import gui.editors.common.InputPane;
import sys.datatypes.question.AutoGenQuestion;

import javax.swing.*;
import java.awt.*;

/**
 * The panel showing the input boxes for question and suggested solution
 * for autogenerating questions. Each of these text boxes have
 * their own tab, in order to make the room for typing as big as possible.
 *
 * @author Eivind Sorteberg - 21.jun.2006
 * @see gui.editors.question.category.QuestionCategoryPanel
 */
public class AutoGenPanel extends DPanel {
    private InputPane question;
    private InputPane formula;

    public AutoGenPanel() {
        super();

        question = new InputPane();
        formula = new InputPane();

        JPanel questionPanel = new JPanel(new GridLayout(1, 1));
        questionPanel.add(new JScrollPane(question));

        JPanel suggSolPanel = new JPanel(new GridLayout(1, 1));
        suggSolPanel.add(new JScrollPane(formula));

        JTabbedPane tabbedPane = new JTabbedPane();
        tabbedPane.add("Code", questionPanel);
        tabbedPane.add("Suggested solution", suggSolPanel);

        this.setLayout(new GridLayout(1, 1));
        this.add(tabbedPane);
    }

    public void showObject(AutoGenQuestion question) {
        this.question.setText(question.getCode());
        this.formula.setText(question.getFormula());
    }

    public void saveObject(AutoGenQuestion question) {
        question.setCode(this.question.getText());
        question.setFormula(this.formula.getText());
    }

    public void setEditable(boolean editable) {
        this.question.setEnabled(editable);
        this.formula.setEnabled(editable);
    }
}
