package gui.editors.question.question;

import gui.editors.common.FormatBar;
import gui.editors.common.InputPane;
import gui.editors.common.Previewable;
import sys.datatypes.question.DarkQuestion;
import sys.models.treemodels.AbstractTreeModel;

import javax.swing.*;
import java.awt.*;

/**
 * @author Eivind Sorteberg - 26.jun.2006
 */
public class DarkQuestionPanel extends JPanel implements Previewable {
    private InputPane input;
    private JRadioButton html;
    private JRadioButton latex;
    private DarkPanel parent;
    private FormatBar formatBar;

    public DarkQuestionPanel(InputPane input, DarkPanel parent) {
        super();
        this.setLayout(new BorderLayout());

        this.parent = parent;

        this.html = new JRadioButton("HTML");
        this.latex = new JRadioButton("LaTeX");

        formatBar = new FormatBar(html, latex, this);

        this.input = input;
        this.add(formatBar, BorderLayout.NORTH);
        this.add(new JScrollPane(input), BorderLayout.CENTER);
    }

    public String[] getText() {
        return new String[]{input.getText()};
    }

    public String getTitle() {
        return null;
    }

    public AbstractTreeModel getModel() {
        return this.parent.getModel();
    }

    public boolean isHtmlSelected() {
        return html.isSelected();
    }

    public InputPane getInputPane() {
        return input;
    }

    public void showObject(DarkQuestion question) {
        if (html.isSelected())          this.input.setText(question.getText());
        else if (latex.isSelected())    this.input.setText(question.getLatex());
    }

    public void saveObject(DarkQuestion question) {
        if (html.isSelected())          question.setText(this.input.getText());
        else if (latex.isSelected())    question.setLatex(this.input.getText());
    }

    public void setEditable(boolean editable) {
        this.formatBar.setEditable(editable);
        this.input.setEnabled(editable);
    }
}
