package gui.editors.question.question;

import gui.editors.common.util.InfoPanelGenerator;

import javax.swing.*;
import java.awt.*;

/**
 * Displays information common for all <code>Question</code> objects.
 * This information is shown above the specific Question information.
 *
 * @author Eivind Sorteberg - 22.jun.2006
 * @see QuestionObjectPanel
 */
public class QuestionInfo extends JPanel {
    public QuestionInfo(JTextField category, JTextField value, JTextArea comment, JButton changeCategory, JRadioButton multChoice, JRadioButton dark, JRadioButton input, JRadioButton autoGen) {
        this.placeComponents(category, value, comment, changeCategory, multChoice, dark, input, autoGen);
    }

    /**
     * @deprecated
     * @param parent
     */
    public QuestionInfo(QuestionObjectPanel parent) {
    }

    private void placeComponents(JTextField category, JTextField value, JTextArea comment, JButton changeCategory, JRadioButton multChoice, JRadioButton dark, JRadioButton input, JRadioButton autoGen) {
        this.setLayout(new BorderLayout());

        ButtonGroup group = new ButtonGroup();
        group.add(multChoice);
        group.add(input);
        group.add(dark);
        group.add(autoGen);
                
        JPanel radioPanel = new JPanel();
        radioPanel.setLayout(new BoxLayout(radioPanel, BoxLayout.X_AXIS));
        radioPanel.add(multChoice);
        radioPanel.add(input);
        radioPanel.add(dark);
        radioPanel.add(autoGen);
        radioPanel.add(Box.createHorizontalGlue());

        JScrollPane commentPane = new JScrollPane(comment);
        commentPane.getViewport().setPreferredSize(new Dimension(
                comment.getPreferredSize().width,
                value.getPreferredSize().height
        ));
        comment.setLineWrap(true);
        comment.setWrapStyleWord(true);
        comment.setCaretPosition(0);    

        JPanel c = new JPanel();
        InfoPanelGenerator.placeComponents(c, 3, 4, new Object[]{
            "Category", category,       changeCategory,
            "Value",    value,          null,
            "Comment",  commentPane,    null,
            "Type",     radioPanel,     null});

        this.add(c, BorderLayout.NORTH);
    }
}
