package gui.editors.text;

import gui.editors.common.AbstractGroupPanel;
import gui.editors.common.util.InfoPanelGenerator;
import sys.datatypes.Group;
import sys.datatypes.TextGroup;

import javax.swing.*;

/**
 * @author Eivind Sorteberg - 28.jul.2006
 */
public class TextGroupPanel extends AbstractGroupPanel {
    private JTextField sequence;
    private int valueBackup;

    protected void placeComponents(JPanel parent) {
        InfoPanelGenerator.placeComponents(parent, 3, 3, new Object[]{
                "Group",            parentGroup,    changeGroup,
                "Name",             name,           null,
                "Sequence #",       sequence,       null
        });
    }

    protected void createComponents() {
        super.createComponents();

        this.sequence = new JTextField();
    }

    public void showObject(Group group) {
        if (!(group instanceof TextGroup)) {
            System.err.println("TextGroupPanel.saveObject() : Illegal group type: " + group.getClass().getName());
            return;
        }

        super.showObject(group);

        int seq = ((TextGroup)group).getSequence();
        this.sequence.setText(Integer.toString(seq));

        this.valueBackup = seq;
    }

    public void saveObject(Group group) {
        if (!(group instanceof TextGroup)) {
            System.err.println("TextGroupPanel.saveObject() : Illegal group type: " + group.getClass().getName());
            return;
        }

        super.saveObject(group);

        int valueTemp;

        try {
            valueTemp = Integer.parseInt(sequence.getText());
        } catch (NumberFormatException e) {
            sequence.setText(Integer.toString(valueBackup));
            valueTemp = valueBackup;
        }

        ((TextGroup)group).setSequence(valueTemp);
    }
}
