package gui.listeners;

import gui.AdminPanel;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Listener for an <code>AdminPanel</code>
 *
 * @author Tarje Killingberg - 20.jun.2006
 */
public class AdminPanelListener implements ActionListener {


    private AdminPanel adminPanel;


    public AdminPanelListener(AdminPanel adminPanel) {
        this.adminPanel = adminPanel;
    }


    /**
     * Called when an ActionEvent has occured in the AdminPanel.
     * Just calls the right methods in AdminPanel.
     *
     * @param e the event that occured
     */
    public void actionPerformed(ActionEvent e) {
        String actionCommand = e.getActionCommand();
        Object source = e.getSource();

        /* Buttons */
        if (source instanceof JButton) {
            if (actionCommand.equalsIgnoreCase("EXAM MODE")) {
                adminPanel.switchExamMode();
            }
            else if (actionCommand.equalsIgnoreCase("New")) {
                adminPanel.newUser();
            }
            else if (actionCommand.equalsIgnoreCase("Delete")) {
                adminPanel.deleteButtonPressed();
            }
            else if (actionCommand.equalsIgnoreCase("Change password")) {
                adminPanel.changePassword();
            }
            else if (actionCommand.equalsIgnoreCase("Select All")) {
                adminPanel.selectAll();
            }
            else if (actionCommand.equalsIgnoreCase("Select None")) {
                adminPanel.selectNone();
            }
            else if (actionCommand.equalsIgnoreCase("Search")) {
                adminPanel.fireFilterChanged();
            }
            else if (actionCommand.equalsIgnoreCase("Clear")) {
                adminPanel.resetFilter();
            }
        }
        /* CheckBoxes */
        else if (source instanceof JCheckBox) {
            if (actionCommand.equalsIgnoreCase("Admin")) {
                adminPanel.fireFilterChanged();
            }
            else if (actionCommand.equalsIgnoreCase("Non-admin")) {
                adminPanel.fireFilterChanged();
            }
        }
        /* TextField */
        else if (source instanceof JTextField) {
            if (((Component)e.getSource()).getName().equalsIgnoreCase("searchTextField")) {
                adminPanel.fireFilterChanged();
            }
            else if (((Component)e.getSource()).getName().equalsIgnoreCase("styleSheetField")) {
                adminPanel.styleSheetChanged();
            }
        }
        /* ComboBox */
        else if (source instanceof JComboBox) {
            if (((Component)e.getSource()).getName().equalsIgnoreCase("searchComboBox")) {
                adminPanel.fireFilterChanged();
            }
            else if (((Component)e.getSource()).getName().equalsIgnoreCase("lastQuestionComboBox")) {
                adminPanel.lastQuestionIDChanged();
            }




        }
    }


}
