package gui.listeners;

import gui.editors.question.question.QuestionObjectPanel;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Listener for the QuestionType selection buttons. Selecting a
 * specific type noifies the <code>QuestionTypeContent</code> that
 * the corresponding panel should be displayed.
 *
 * @author Eivind Sorteberg - 21.jun.2006
 * @see QuestionObjectPanel
 * @see gui.editors.question.question.QuestionTypeContent
 */
public class QuestionTypeListener implements ActionListener {
    private QuestionObjectPanel panel;

    public QuestionTypeListener(QuestionObjectPanel panel) {
        this.panel = panel;
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() instanceof JRadioButton) {
            this.panel.switchPanel((JRadioButton)e.getSource());
        }
    }
}
