package gui.listeners;

import sys.datatypes.interfaces.AoCObject;
import sys.models.treemodels.AbstractTreeModel;

import javax.swing.*;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;

/**
 * Listener used to notify the corresponding <code>TreeModel</code> whenever
 * selection in the tree is changed.
 *
 * @author Eivind Sorteberg
 */
public class SuperTreeSelectionListener implements TreeSelectionListener {
    private AbstractTreeModel model;

    public void setModel(AbstractTreeModel model) {
        this.model = model;
    }

    public void valueChanged(TreeSelectionEvent e) {
        if (e instanceof AoCObject) {

        }
        else if (!(e.getSource() instanceof JTree)) System.err.println("ERROR: Expected e.source JTree, found " + e.getSource().getClass());
        else {
            Object o = ((JTree)e.getSource()).getLastSelectedPathComponent();

            if (o instanceof AoCObject) {
                model.fireNodeSelected((AoCObject)o);
                
            }
        }
    }
}
