package gui.tabs;

import gui.editors.question.QuestionEditor;
import gui.tree.QuestionTreePanel;
import sys.models.treemodels.AbstractTreeModel;
import sys.models.treemodels.QuestionTreeModel;

/**
 * The tab containing the tree and the editor panel
 * for the question-related editor view.
 *
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class QuestionTab extends AbstractTab {
    public QuestionTab() {
        super();
    }

    public void setEditor() {
        this.editor = new QuestionEditor();
    }

    public void setTree() {
        this.tree = new QuestionTreePanel();
    }

    /**
     * Sets the model for this tab. Should take a
     * <code>QuestionTreeModel</code> as in parameter.
     *
     * @param model The model representing the current Question view
     * @see sys.models.treemodels.QuestionTreeModel
     */
    public void setModel(AbstractTreeModel model) {
        if (model instanceof QuestionTreeModel) {
            this.model = model;
            this.tree.setModel(model);
            this.treelistener.setModel(model);
            this.editor.setModel(model);
        }
        else {
            System.err.println("Illegal model: Expected QuestionTreeModel, found " + model.getClass());
        }
    }

    public String toString() {
        return "Question Editor";
    }
}
