package gui.tabs;

import gui.editors.text.TextEditor;
import gui.tree.TextTreePanel;
import sys.models.treemodels.AbstractTreeModel;
import sys.models.treemodels.TextTreeModel;

/**
 * The tab containing the tree and the editor panel
 * for the text-related editor view.
 *
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class TextTab extends AbstractTab {
    public TextTab() {

    }

    public void setEditor() {
        this.editor = new TextEditor();
    }

    public void setTree() {
        this.tree = new TextTreePanel();
    }

    /**
     * Sets the model for this tab. Should take a
     * <code>TextTreeModel</code> as in parameter.
     *
     * @param model The model representing the current Text view
     * @see sys.models.treemodels.TextTreeModel
     */
    public void setModel(AbstractTreeModel model) {
        if (model instanceof TextTreeModel) {
            this.model = model;
            this.treelistener.setModel(model);
            this.tree.setModel(model);
            this.editor.setModel(model);
        }
        else {
            System.err.println("Illegal model: Expected TextTreeModel, found " + model.getClass());
        }
    }

    public String toString() {
        return "Text Editor";
    }
}
