package gui.tree;

import javax.swing.*;
import javax.swing.tree.TreeSelectionModel;

/**
 * A <code>JTree</code> implementation, with certain attributes
 * defined.
 *
 * @author Eivind Sorteberg - 29.jun.2006
 */
public class SuperTree extends JTree {
    public SuperTree() {
        super();

        TreeRenderer treeRenderer = new TreeRenderer();
        this.setCellRenderer(treeRenderer);

        this.setOpaque(false);

        this.setRootVisible(true);
        this.setShowsRootHandles(false);

        this.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);

        ToolTipManager.sharedInstance().registerComponent(this);
    }
}


