package sys;

import gui.LoginFrame;
import gui.MainFrame;
import gui.SQLTrace;

import javax.swing.*;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * Application main class.
 * Sets the L&F and starts the application.
 *
 * @author Tarje Killingberg - 19.jun.2006
 */
public class AoCAdmin {


    public static String DATABASE_SERVER = "";
    public static String DATABASE_USERNAME = "";
    public static String DATABASE_PASSWORD = "";

    public static String WEB_SERVER = "";
    public static String DATA_FOLDER = "data/";
    public static String MAP_FOLDER = "data/map/";
    public static String ICON_FOLDER = "data/icons/";
    public static String TREE_ICON_FOLDER = "data/icons/treeicons/";

    public static String SETTINGS_FOLDER = "data/settings/";

    public static boolean LOGIN_OK = false;

    public AoCAdmin() {
        SQLTrace.init();

        new LoginFrame();

        while (!LOGIN_OK) {
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
            }
        }

        new MainFrame();
    }


    /**
     * Application entry point
     *
     * @param args
     */
    public static void main(String[] args) {


        /* Redirect the standard error stream to our own nice error-log */
        try {
            PrintStream errStream = new PrintStream("errLog.txt");

            System.setErr(errStream);

            Calendar calendar = new GregorianCalendar();
            calendar.setFirstDayOfWeek(Calendar.MONDAY);
            String s = "****************************************************************************\n" +
                    "*****                       " +
                    DateFormat.getDateTimeInstance(DateFormat.MEDIUM, DateFormat.MEDIUM).format(new Date()) +
                    "                       *****\n" +
                    "***** This file contains the error log for last execution of AoC Admin *****\n" +
                    "****************************************************************************\n" +
                    "\n" +
                    "\n";
            errStream.write(s.getBytes());

        } catch (FileNotFoundException e) {
            System.err.println(e.getClass() + ": " + e.getMessage());
        } catch (SecurityException e) {
            System.err.println(e.getClass() + ": " + e.getMessage());
        } catch (IOException e) {
            System.err.println(e.getClass() + ": " + e.getMessage());
        }

        /* Change the look-and-feel */
        try {
            UIManager.setLookAndFeel("com.nilo.plaf.nimrod.NimRODLookAndFeel");
        } catch (Exception e) {
            System.err.println(e.getClass() + ": " + e.getMessage());
        }

        /* Start the application */
        new AoCAdmin();
    }

}
