package sys;

import sys.datatypes.MapPosition;

/**
 * Contains default value for various stuff.
 * Those not set here are set when the
 * Settings-table is read.
 *
 * @author Tarje Killingberg - 13.jul.2006
 */
public class DefaultValues {

    /* ----- GENERAL ----- */

    /** Default level id for new MapItems */
    public static int MAPITEM_LEVEL_ID = 100;
    /** Default MapPosition for MapItems */
   public static MapPosition MAPITEM_MAP_POSITION = new MapPosition(10, 10, 0);


    /* ----- USERS ----- */

    /** Default level id for new users */
    public static int USER_LEVEL_ID = 100;
     /** Default MapPosition for new users */
    public static MapPosition USER_MAP_POSITION = new MapPosition(10, 10, 0);


    /* ----- QUESTIONS ----- */

    /** Default category for new questions */
    public static int QUESTION_CATEGORY = 1;
    /** Default group for new categories. Is set with value from DB */
    public static int QUESTION_GROUP;
    /** Default root for the question model. Is set with value from DB */
    public static int QUESTION_ROOT;
    /** The ID of the last question in the game */
    public static int LAST_QUESTION_ID;


    /* ----- TEXTS -----*/

    /** Default TextGroup for new Texts. Is set with value from DB */
    public static int TEXT_GROUP;
    /** Default root for the text model. Is set with value from DB */
    public static int TEXT_ROOT;


    public static String STYLE_CSS_FILE = "";
}
