package sys.datatypes;

import sys.datatypes.interfaces.AoCObject;

import java.util.HashMap;

/**
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class Fact extends Text {
    public Fact(int id, int parent_id, String name, String text, String latex, int level, MapPosition position, int sequence) {
        super(id, parent_id, name, text, latex, level, position, sequence);
    }

    public Fact(int levelId, MapPosition mapPosition) {
        super("New Fact", levelId, mapPosition);
    }

    public Fact() {
        super("New Fact");
    }

    public Object[] getFieldValues() {
        return super.getAttributes("fact");
    }

    public void setAllAttributes(HashMap<String, Object> attributes) {
        super.setAllAttributes(attributes);
    }


    public static String printArray(Object[] array) {
        String s = "[";

        for (int i = 0; i < array.length - 1; i++) {
            s += array[i] + ", ";
        }

        s += array[array.length - 1] + "]";
        return s;
    }

    public boolean differsFrom(AoCObject object) {
        if (!(object instanceof Fact)) return true;

        return super.differsFrom(object);
    }

    public AoCObject makeClone() {
        return new Fact(getId(),
                           getParent_id(),
                           getName(),
                           getText(),
                           getLatex(),
                           getLevel(),
                           new MapPosition(getMapPosition().getX(),
                                           getMapPosition().getY(),
                                           getMapPosition().getZ()),
                           getSequence());
    }

    public String getStatusName() {
        return "Fact";
    }
}
