package sys.datatypes;

import sys.datatypes.interfaces.AoCObject;

import java.util.HashMap;

/**
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class History extends Text {
    public History(int id, int parent_id, String name, String text, String latex, int level, MapPosition position, int sequence) {
        super(id, parent_id, name, text, latex, level, position, sequence);
    }

    public History(int levelId, MapPosition mapPosition) {
        super("New History", levelId, mapPosition);
    }

    public History() {
        super("New History");
    }

    public Object[] getFieldValues() {
        return super.getAttributes("history");
    }

    public void setAllAttributes(HashMap<String, Object> attributes) {
        super.setAllAttributes(attributes);
    }

    public String getStatusName() {
        return "History";
    }


    public boolean differsFrom(AoCObject object) {
        if (!(object instanceof History)) return true;

        return  super.differsFrom(object);
    }


    public AoCObject makeClone() {
        return new History(getId(),
                           getParent_id(),
                           getName(),
                           getText(),
                           getLatex(),
                           getLevel(),
                           new MapPosition(getMapPosition().getX(),
                                           getMapPosition().getY(),
                                           getMapPosition().getZ()),
                           getSequence());
    }
}
