package sys.datatypes.interfaces;

import sys.datatypes.MapPosition;
import sys.models.LevelModel;

/**
 * A MapItem is an object which is visible on the map,
 * that is an item that has a position, and can be moved.
 *
 * @author Eivind Sorteberg - 19.jun.2006
 * @see sys.datatypes.Message
 * @see sys.datatypes.TeleportSource
 * @see sys.datatypes.TeleportDestination
 * @see sys.datatypes.Fact
 * @see sys.datatypes.History
 * @see sys.datatypes.question.QuestionCategory
 */
public interface MapItem {


    /**
     * Moves the MapItem to a new posision on the same map
     *
     * @param x
     * @param y
     */
    public void moveTo(int x, int y);


    /**
     * Moves the MapItem to a new posision on the same map
     *
     * @param x
     * @param y
     * @param z
     */
    public void moveTo(int x, int y, int z);


    /**
     * Gets this MapItems MapPosition-object
     *
     * @return this MapItems MapPosition-object
     */
    public MapPosition getMapPosition();


    /**
     * Sets this MapItems MapPosition-object
     */
    public void setMapPosition(MapPosition mapPosition);


    /**
     * Gets this MapItems LevelModel
     *
     * @return this MapItems LevelModel
     */
    public LevelModel getLevelModel();


    /**
     * Sets this MapItems LevelModel
     */
    public void setLevelModel(LevelModel lm);
}
