package sys.datatypes.question;

import sys.datatypes.interfaces.AoCObject;

import java.util.HashMap;

/**
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class DarkQuestion extends Question {
    public static final String DB_NAME = "DarkQuestion";

    private String code;
    private String oldCode;
    private String suggSol;
    private String testCode;

    public DarkQuestion(int id, int parent_id, String text, String latex, int value, String comment, String code, String oldCode, String testCode, String suggSol) {
        super(id, parent_id, text, latex, value, comment);
        this.code = code;
        this.oldCode = oldCode;
        this.testCode = testCode;
        this.suggSol = suggSol;
    }

    public DarkQuestion() {
        super();
        this.code = "";
    }

    public String getCode() {
        return code != null ? code : "";
    }

    public String getOldCode() {
        return oldCode != null ? oldCode : "";
    }

    public String getSuggSol() {
        return suggSol != null ? suggSol : "";
    }

    public String getTestCode() {
        return testCode != null ? testCode : "";
    }

    public void setTestCode(String testCode) {
        this.testCode = testCode;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public void setOldCode(String oldCode) {
        this.oldCode = oldCode;
    }

    public void setSuggSol(String suggSol) {
        this.suggSol = suggSol;
    }

    public Object[] getSpecialAttributes() {
        return new Object[]{getCode(), getOldCode(), getTestCode(), getSuggSol()};
    }

    public String[] getSpecialFieldNames() {
        return new String[]{"Code", "OldCode", "TestCode", "SuggestedSolution"};
    }

    public String getSpecialDBname() {
        return DB_NAME;
    }

/* ------ Methods from interface AoCObject ----- */


    public Object[] getFieldValues() {
        return super.getAttributes("dark");
    }

    public AoCObject makeClone() {

        return new DarkQuestion(
                this.getId(),
                this.getParent_id(),
                this.getText(),
                this.getLatex(),
                this.getValue(),
                this.getComment(),
                this.getCode(),
                this.getOldCode(),
                this.getTestCode(),
                this.getSuggSol());
    }

    public boolean differsFrom(AoCObject object) {
        if (!(object instanceof DarkQuestion)) return true;

        DarkQuestion q2 = (DarkQuestion)object;

        return  this.getId() != q2.getId() ||
                this.getParent_id() != q2.getParent_id() ||
                !this.getText().equals(q2.getText()) ||
                !this.getLatex().equals(q2.getLatex()) ||
                this.getValue() != q2.getValue() ||
                !this.getComment().equals(q2.getComment()) ||
                !this.getCode().equals(q2.getCode()) ||
                !this.getTestCode().equals(q2.getTestCode()) ||
                !this.getSuggSol().equals(q2.getSuggSol()) ||
                !this.getOldCode().equals(q2.getOldCode());
    }

    public void setAllAttributes(HashMap<String, Object> attributes) {
        super.setAllAttributes(attributes);
        this.setCode((String)attributes.get("Code"));
        this.setTestCode((String)attributes.get("TestCode"));
        this.setSuggSol((String)attributes.get("SuggestedSolution"));
        this.setOldCode((String)attributes.get("OldCode"));
    }

}
