package sys.datatypes.question;

import sys.datatypes.interfaces.AoCObject;

import java.util.HashMap;

/**
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class InputQuestion extends Question {
    public static final String DB_NAME = "InputQuestion";

    private String answer;

    public InputQuestion(int id, int parent_id, String text, String latex, int value, String comment, String answer) {
        super(id, parent_id, text, latex, value, comment);
        this.answer = answer;
    }

    public InputQuestion() {
        super();
    }

    public String getAnswer() {
        return answer != null ? answer : "";
    }

    public void setAnswer(String answer) {
        this.answer = answer;
    }

    public Object[] getSpecialAttributes() {
        return new Object[]{getAnswer()};
    }

    public String[] getSpecialFieldNames() {
        return new String[]{"Answer"};
    }

    public String getSpecialDBname() {
        return DB_NAME;
    }



    /* ------ Methods from interface AoCObject ----- */


    public Object[] getFieldValues() {
        return super.getAttributes("input");
    }

    public AoCObject makeClone() {
        return new InputQuestion(
                this.getId(),
                this.getParent_id(),
                this.getText(),
                this.getLatex(),
                this.getValue(),
                this.getComment(),
                this.getAnswer());
    }


    public boolean differsFrom(AoCObject object) {
        if (!(object instanceof InputQuestion)) return true;

        InputQuestion q2 = (InputQuestion)object;

        return  this.getId() != q2.getId() ||
                this.getParent_id() != q2.getParent_id() ||
                !this.getText().equals(q2.getText()) ||
                !this.getLatex().equals(q2.getLatex()) ||
                this.getValue() != q2.getValue() ||
                !this.getComment().equals(q2.getComment()) ||
                !this.getAnswer().equals(q2.getAnswer());

    }

    public void setAllAttributes(HashMap<String, Object> attributes) {
        super.setAllAttributes(attributes);
        this.setAnswer((String)attributes.get("Answer"));
    }

}
