package sys.datatypes.question;

import sys.datatypes.interfaces.AoCObject;

import java.util.HashMap;

/**
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class MultiChoiceAlternative implements AoCObject, Comparable<MultiChoiceAlternative> {
    public static final String DB_NAME = "MultiChoiceAlternative";

    private int id;
    private int question_id;
    private String text;
    private String latex;

    public MultiChoiceAlternative(int id, int question_id, String text, String latex) {
        this.id = id;
        this.question_id = question_id;
        this.text = text;
        this.latex = latex;
    }

    public MultiChoiceAlternative(int id, int question_id) {
        this.id = id;
        this.question_id = question_id;
    }


    public int getQuestion_id() {
        return question_id;
    }

    public void setQuestion_id(int question_id) {
        this.question_id = question_id;
    }

    public String getText() {
        return text != null ? text : "";
    }

    public void setText(String text) {
        this.text = text;
    }

    public String getLatex() {
        return latex != null ? latex : "";
    }

    public void setLatex(String latex) {
        this.latex = latex;
    }

    public boolean isCorrect() {
        return false;
    }



    /* ------ Methods from interface AoCObject ----- */


    public String getDBname() {
        return DB_NAME;
    }


    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String[] getIdFields() {
        return new String[]{"QuestionID", "AlternativeID"};
    }


    public Object[] getIdValues() {
        return new Object[]{getQuestion_id(), getId()};
    }


    public String[] getFieldNames() {

        return new String[]{"QuestionID",
                            "AlternativeID",
                            "Text",
                            "LaTeX"};

    }

    public Object[] getFieldValues() {

        return new Object[]{this.getQuestion_id(),
                            this.getId(),
                            this.getText(),
                            this.getLatex()};

    }

    public void setAllAttributes(HashMap<String, Object> attributes) {
        this.setId((Integer)attributes.get("AlternativeID"));
        this.setQuestion_id((Integer)attributes.get("QuestionID"));
        this.setText((String)attributes.get("Text"));
        this.setLatex((String)attributes.get("LaTeX"));
    }


    public AoCObject makeClone() {
        return new MultiChoiceAlternative(this.getId(),
                                          this.getQuestion_id(),
                                          this.getText(),
                                          this.getLatex());

    }


    public boolean differsFrom(AoCObject object) {
        if (!(object instanceof MultiChoiceAlternative)) return true;

        MultiChoiceAlternative m2 = (MultiChoiceAlternative)object;

        return  this.getId() != m2.getId() ||
                this.getQuestion_id() != m2.getQuestion_id() ||
                !this.getText().equals(m2.getText()) ||
                !this.getLatex().equals(m2.getLatex());

    }

    public int compareTo(MultiChoiceAlternative o) {
        return this.getId() - o.getId();
    }

    public String toString() {
        return this.getQuestion_id() + ": " + this.getId();
    }

    public HashMap<String, Object> getAllAttributes() {
        HashMap<String, Object> attributes = new HashMap<String, Object>();

        String[] idFields = getIdFields();
        Object[] idValues = getIdValues();

        for (int i = 0; i < idFields.length; i++) {
            attributes.put(idFields[i], idValues[i]);
        }

        String[] otherFields = getFieldNames();
        Object[] otherValues = getFieldValues();

        for (int i = 0; i < otherFields.length; i++) {
            attributes.put(otherFields[i], otherValues[i]);
        }

        return attributes;
    }

    public Object[][] getAttributeArray() {
        return new Object[0][];
    }

    public String getInfo() {
        String s = "";

        for (int i = 0; i < getIdFields().length; i++) {
            s += "\n----------------------------\n" + getIdFields()[i] + "\n----------------------------\n" + getIdValues()[i] + "\n";
        }
        for (int i = 0; i < getFieldNames().length; i++) {
            s += "\n----------------------------\n" + getFieldNames()[i] + "\n----------------------------\n" + getFieldValues()[i] + "\n";
        }

        return s;
    }

    public String getInfo(int coloredAttributes) {
        return getInfo();
    }
}
