package sys.datatypes.question;

import sys.DefaultValues;
import sys.datatypes.Group;
import sys.datatypes.interfaces.AoCObject;

import java.util.HashMap;

/**
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class QuestionGroup extends Group {
    public static final String DB_NAME = "QuestionGroup";

    public QuestionGroup(int id, int parent, String name, String text) {
        super(id, parent, name, text);
    }

    public QuestionGroup() {
        super(-1, DefaultValues.QUESTION_GROUP, "New Group", null);
    }

    /* ----- Methods from interface AoCObject ----- */
    public String[] getFieldNames() {
        return new String[]{"ParentID",
                            "Name",
                            "Description"};
    }

    public String getDBname() {
        return DB_NAME;
    }

    public String getToolTipText() {
        return "<html><b>ID:</b> " + getId() + "<br><b>Name:</b> " + getName() + "<br><b>Group ID:</b> " + getParent_id() + "</html>";
    }


    public AoCObject makeClone() {
        return new QuestionGroup(this.getId(),
                                 this.getParent_id(),
                                 this.getName(),
                                 this.getDescription());
    }

    public void setAllAttributes(HashMap<String, Object> attributes) {
        super.setAllAttributes(attributes);
        this.setParent_id((Integer)attributes.get("ParentID"));
        this.setDescription((String)attributes.get("Description"));
    }

    public String getStatusName() {
        return "Question Group";
    }
}
