package sys.models;

import sys.datatypes.interfaces.AoCObject;

/**
 * Wraps two corresponding AoCObjects; the original object
 * and the new, changed object.
 * Is used to determine whether the original object has been
 * changed by external parts prior to writing the new
 * object to the database.
 * 
 * @author Eivind Sorteberg - 19.jun.2006
 */
public class ChangedObjectWrapper {


    private AoCObject oldObject;
    private AoCObject newObject;


    public ChangedObjectWrapper(AoCObject oldObject) {
        this.oldObject = oldObject;
    }


    public void objectChanged(AoCObject newObject) {
        this.newObject = newObject;
    }


    public AoCObject getOldObject() {
        return oldObject;
    }


    public AoCObject getNewObject() {
        return newObject;
    }


    public String toString() {
        return "Old: " + oldObject + "; New:" + newObject;
    }
}
